import 'package:flutter/material.dart';

abstract class FieldWidget extends StatefulWidget {
  late final TextInputAction _action;
  late final String? _hint;
  late final bool _isEnabled;

  FieldWidget(
      {TextInputAction action = TextInputAction.next,
      String? hint,
      bool isEnabled = true,
      Key? key})
      : super(key: key) {
    _action = action;
    _hint = hint;
    _isEnabled = isEnabled;
  }

  TextInputAction get action => _action;

  String? get hint => _hint;

  bool get isEnabled => _isEnabled;
}
